package com.steerinfo.route.service.impl;


import com.steerinfo.route.mapper.TmstruckArrivalResultMapper;
import com.steerinfo.route.model.TmstruckArrivalResult;
import com.steerinfo.route.service.ITmstruckArrivalResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmstruckArrivalResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:38
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：TmstruckArrivalResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstruckArrivalResultService")
public class TmstruckArrivalResultServiceImpl implements ITmstruckArrivalResultService {

    @Autowired
    private TmstruckArrivalResultMapper tmstruckArrivalResultMapper;


//    @Override
//    public synchronized int addtmstruckArrivalResult(String orderNumber,TmstruckArrivalResult tmstruckArrivalResult) {
//        long id;
//        if(tmstruckArrivalResultMapper.selectMaxId()==null){
//            id = 1;
//        }else {
//            id = tmstruckArrivalResultMapper.selectMaxId().longValue()+1;
//        }
//        //生成主键id
//        tmstruckArrivalResult.setResultId(new BigDecimal(id));
//        //获取并插入总实绩Id
//        BigDecimal truckTotalId = tmstruckAbnormalResultMapper.getTotalIdByOrderNumber(orderNumber);
//        tmstruckArrivalResult.setResultTotalId(truckTotalId);
//        //常规字段
//        tmstruckArrivalResult.setInsertUsername("admin");
//        tmstruckArrivalResult.setInsertTime(new Date());
//        tmstruckArrivalResult.setUpdateUsername("admin");
//        tmstruckArrivalResult.setUpdateTime(new Date());
//        tmstruckArrivalResult.setInsertUpdateRemark("无");
//        return tmstruckArrivalResultMapper.insert(tmstruckArrivalResult);
//    }

    @Override
    public synchronized int addtmstruckArrivalResult(String orderNumber, TmstruckArrivalResult tmstruckArrivalResult) {
        //通过运输订单号查询是否已存在抵达实绩
        BigDecimal alreadyExistsArrivalResult = tmstruckArrivalResultMapper.alreadyExistsArrivalResult(orderNumber);
        if(alreadyExistsArrivalResult==null){
            long id;
            if(tmstruckArrivalResultMapper.selectMaxId()==null){
                id = 1;
            }else {
                id = tmstruckArrivalResultMapper.selectMaxId().longValue()+1;
            }
            //生成主键id
            tmstruckArrivalResult.setResultId(new BigDecimal(id));
            //获取并插入总实绩Id
            BigDecimal truckTotalId = tmstruckArrivalResultMapper.getTotalIdByOrderNumber(orderNumber);
            tmstruckArrivalResult.setResultTotalId(truckTotalId);
            //常规字段
            tmstruckArrivalResult.setInsertUsername("admin");
            tmstruckArrivalResult.setInsertTime(new Date());
            tmstruckArrivalResult.setUpdateUsername("admin");
            tmstruckArrivalResult.setUpdateTime(new Date());
            tmstruckArrivalResult.setInsertUpdateRemark("无");
            return tmstruckArrivalResultMapper.insert(tmstruckArrivalResult);
        }else{
            return 3;
        }

    }

    @Override
    public List<Map<String, Object>> getArrivalResultInfo(Map<String, Object> map) {
        return tmstruckArrivalResultMapper.getArrivalResultInfo(map);
    }

    @Override
    public String getAddressDistrict(String orderNumber) {
        return tmstruckArrivalResultMapper.getAddressDistrict(orderNumber);
    }

    @Override
    public List<String> getAdjustment() {
        return tmstruckArrivalResultMapper.getAdjustment();

    }

    @Override
    public int updateTown(String city, String item) {
        return tmstruckArrivalResultMapper.updateTown(city,item);
    }
}
